/*
 * MIT License
 *
 * Copyright (c) 2018-2019 Daniel Cortes
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package danielcortes.xyz.views.components.table_model;

import danielcortes.xyz.models.ingreso.Ingreso;
import java.text.NumberFormat;
import java.util.ArrayList;
import javax.swing.table.AbstractTableModel;

public class IngresosTableModel extends AbstractTableModel {

  private String[] columns;
  private ArrayList<Ingreso> rows;
  private NumberFormat nf;

  public IngresosTableModel() {
    super();
    this.columns = new String[]{"Valor", "N° Z Inicial", "N° Z Final", "N° Inicial", "N° Final",
        "Tipo"};
    this.rows = new ArrayList<>();
    this.nf = NumberFormat.getIntegerInstance();
  }

  @Override
  public String getColumnName(int col) {
    return this.columns[col];
  }

  @Override
  public int getColumnCount() {
    return this.columns.length;
  }

  @Override
  public int getRowCount() {
    return this.rows.size();
  }

  @Override
  public Object getValueAt(int row, int col) {
    switch (col) {
      case 0:
        return nf.format(this.rows.get(row).getValor());
      case 1:
        return this.rows.get(row).getNroZInicial();
      case 2:
        return this.rows.get(row).getNroZFinal();
      case 3:
        return this.rows.get(row).getNroInicial();
      case 4:
        return this.rows.get(row).getNroFinal();
      case 5:
        return this.rows.get(row).getTipoIngreso().getNombre();
    }
    return null;
  }

  public void addRow(Ingreso ingreso) {
    this.rows.add(ingreso);
    this.fireTableRowsInserted(getRowCount() - 1, getRowCount() - 1);
  }

  public void removeRow(int row) {
    this.rows.remove(row);
    this.fireTableRowsDeleted(row, row);
  }

  public void removeRows() {
    int rowCount = getRowCount();
    if (rowCount > 0) {
      this.rows.clear();
      this.fireTableRowsDeleted(0, rowCount - 1);
    }
  }

  public Ingreso getIngreso(int row) {
    return this.rows.get(row);
  }

  public void setIngreso(int editingId, Ingreso ingreso) {
    this.rows.set(editingId, ingreso);
    this.fireTableRowsUpdated(getRowCount() - 2, getRowCount() - 1);
  }

}
